#include <math.h>
#include <stdio.h>


#define NUM_ITEMS 36
#define is_member(S, X) ((S >> X) & 1)

int main() {
  const int MAX_NUM_PICKED = 5;
    
  // double weights[NUM_ITEMS] = {1, 1, 1, 1, 1, 0.5, 0.2, 0.8, 0.9, 0.1};
  const double weights[NUM_ITEMS] = {
    1, 1, 1, 1, 1,
    0.5, 0.2, 0.8, 0.9, 0.1,
    0.5, 0.5, 0.5, 0.5, 0.5,
    0.2, 0.3, 0.4, 0.9, 0.1,
    0.25, 0.333, 0.4, 0.1, 0.5,
    0.6, 0.15, 0.625, 0.375, 0.40};
    
  double weights_log[NUM_ITEMS];
  double comp_weights_log[NUM_ITEMS];
  double final_prob[NUM_ITEMS];

  for (int i=0; i<NUM_ITEMS; i++) {
    final_prob[i] = 0.0;
    weights_log[i] = log(weights[i]);
    comp_weights_log[i] = log(1-weights[i]);
  }

  unsigned long long int num_subsets = (1 << NUM_ITEMS);
  unsigned long long int subset;

  for (subset = 0; subset < num_subsets; subset++) {
    double tmp_prob = 0.0;
    int subset_size = 0;
    for(int i=0; i<NUM_ITEMS; i++) {
      if ((subset >> i)&1) {
	subset_size++;
	if(weights[i] == 0.0) {tmp_prob = -1; break;}
	tmp_prob += weights_log[i];

      }
      else {
	if(weights[i] == 1.0) {tmp_prob = -1; break;}
	tmp_prob += comp_weights_log[i];
      }      
    }

    if(tmp_prob == -1) {
      // impossible event
      continue;
    }

    int num_drawn = (subset_size < MAX_NUM_PICKED) ? subset_size : MAX_NUM_PICKED; 
    tmp_prob = exp(tmp_prob) * num_drawn / subset_size;

    for(int i=0; i<NUM_ITEMS; i++) {
      if ((subset >> i)&1) {
	// printf("%d %f %f\n", i, final_prob[i], tmp_prob);
	final_prob[i] += tmp_prob;
      }
      // DEBUG
      if(subset & 0xff == 0xff) {
	printf("%d: %f\n", i, final_prob[i]);
	if(i+1 == NUM_ITEMS){
	  printf("\n");
	}
      }
    }

  }



  printf("\n----------------------");
  for(int i=0; i<NUM_ITEMS; i++) {
    printf("%d: %f\n", i, final_prob[i]);
  }
}

